<template>
  <div>
    <div class="subTitulo">
      Resumen de sucursal
      <br />
      {{ceco}} - {{nombreCeco}}
    </div>
    <div class="divCol resumen">
      <div class="col2 resumen__sucursal" ref="total" v-on:click="$emit('click', 4); cambiaColor(4)" >
        <div>
          <div>Total de hallazgos</div>
          <div class="txt">{{this.total}}</div>
        </div>
        <div>
          <img src="@/assets/img/hallazgos/icoTotal.svg" />
        </div>
      </div>
      <div class="col2 resumen__sucursal" ref="PAtender" v-on:click="$emit('click', 1); cambiaColor(1)">
        <div>
          Por atender
          <div class="txt">{{this.porAtender}}</div>
        </div>
        <div>
          <img src="@/assets/img/hallazgos/icoPorAtender.svg" />
        </div>
      </div>
      <div class="col2 resumen__sucursal"  ref="PAutorizar" v-on:click="$emit('click', 2); cambiaColor(2)">
        <div>
          Por autorizar
          <div class="txt">{{this.porAutorizar}}</div>
        </div>
        <div>
          <img src="@/assets/img/hallazgos/icoPorAutorizar.svg" />
        </div>
      </div>
      <div class="col2 resumen__sucursal"  ref="RPAtender" v-on:click="$emit('click', 0); cambiaColor(0)">
        <div>
          Rechazados por atender
          <div class="txt">{{this.rechazadosPorAtender}}</div>
        </div>
        <div>
          <img src="@/assets/img/hallazgos/icoRechazadasPorAtender.svg" />
        </div>
      </div>
      <div class="col2 resumen__sucursal" ref="Atendidos" v-on:click="$emit('click', 3); cambiaColor(3)">
        <div>
          Atendidos
          <div class="txt">{{this.atendidos}}</div>
        </div>
        <div>
          <img src="@/assets/img/hallazgos/icoAtendidos.svg" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
  //props: { hallazgos: Array },
  props: {
    idCeco: String,
    idFase: String,
    idProyecto: String,
    nombreCecoParam: String,
    numCecoParam: String
  },
  name: "busqueda-resumen",
  data() {
    return {
      hallazgos: [],
      ceco: "",
      nombreCeco: "",
      total: 0,
      porAtender: 0,
      porAutorizar: 0,
      rechazadosPorAtender: 0,
      atendidos: 0,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Atención de hallazgos",
          disabled: false,
          exact: true,
          to: {
            name: "maquetado_hallazgos-busqueda"
          }
        },
        {
          text: "Detalle de Hallazgos",
          disabled: true
        }
      ]
    };
  },
  created() {
    this.getHallazgos();
  },
  methods: {
    initData(hallazgos) {

      this.total = 0
      this.porAtender= 0
      this.porAutorizar= 0
      this.rechazadosPorAtender= 0
      this.atendidos = 0,
      this.getDatosCeco(hallazgos);
      this.getConteo(hallazgos);
    },
    cambiaColor(estatus){
      this.$refs.RPAtender.style.backgroundColor = ''
      this.$refs.PAtender.style.backgroundColor = ''
      this.$refs.PAutorizar.style.backgroundColor = ''
      this.$refs.Atendidos.style.backgroundColor = ''
      this.$refs.total.style.backgroundColor = ''

      switch(estatus){
        case 0:
          this.$refs.RPAtender.style.backgroundColor = '#fff9e6'
          break;
        case 1:
          this.$refs.PAtender.style.backgroundColor = '#fff9e6'
          break;
        case 2:
          this.$refs.PAutorizar.style.backgroundColor = '#fff9e6'
          break;
        case 3:
          this.$refs.Atendidos.style.backgroundColor = '#fff9e6'
          break;
        case 4:
          this.$refs.total.style.backgroundColor = '#fff9e6'
          break;

      }
    },

    actualizaHallazgos(){
      
      this.getHallazgos()

      this.$refs.RPAtender.style.backgroundColor = '#ffffff'
      this.$refs.PAtender.style.backgroundColor = '#ffffff'
      this.$refs.PAutorizar.style.backgroundColor = '#ffffff'
      this.$refs.Atendidos.style.backgroundColor = '#ffffff'
      this.$refs.total.style.backgroundColor = '#ffffff'
    },
    getHallazgos() {
      axiosChecklist
        .get(
          "expansionCoreServices/getHallazgosExpansionCore.json?ceco=" +
            this.idCeco +
            "&proyecto=" +
            this.idProyecto +
            "&fase=" +
            this.idFase,
          {
            responseType: "json"
          }
        )
        .then(response => {
          if (response) {
            if (response.status === 200) {
              this.initData(response.data);
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getDatosCeco(arrayHallazgosParam) {
      if (arrayHallazgosParam != null && arrayHallazgosParam.length > 0) {
        this.ceco = arrayHallazgosParam[0].ceco;
        this.nombreCeco = arrayHallazgosParam[0].cecoNom;
      } else {
        this.ceco = this.numCecoParam;
        this.nombreCeco = this.nombreCecoParam;
      }
    },
    getConteo(arrayHallazgosParam) {
      if (arrayHallazgosParam != null && arrayHallazgosParam.length > 0) {
        this.total = arrayHallazgosParam.length;
        Object.keys(arrayHallazgosParam).forEach(key => {
          var obj = arrayHallazgosParam[key];

          switch (obj.status) {
            case 0:
              this.rechazadosPorAtender++;
              break;
            case 1:
              this.porAtender++;
              break;
            case 2:
              this.porAutorizar++;
              break;
            case 3:
              this.atendidos++;
              break;
            default:
              break;
          }
        });
      
      if(this.atendidos === this.total){
        this.$emit('cerohallazgos',true)
      }

      }
    }
  }
};
</script>

<style scoped>
.resumen > div {
  border: 1px solid #d0d0ce;
}

.resumen .theme--light.v-card.v-card--outlined {
  border: thin solid rgba(0, 0, 0, 0.12);
  box-shadow: 1px 4px 5px rgb(226, 222, 222);
}
.theme--light.v-card {
  background-color: red;
}
.resumen {
  width: 100%;
  margin: 0 auto 20px auto;
  display: grid;
  grid-template-columns: repeat(10, 1fr);
  grid-gap: 20px;
  align-items: stretch;
}
.resumen .col2 {
  grid-column: auto / span 2;
}

.resumen__sucursal {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  padding: 5px 10px;
}

.resumen__sucursal:nth-child(1) {
  border-bottom: 4px solid #575757;
}
.resumen__sucursal:nth-child(2) {
  border-bottom: 4px solid #ea3425;
}
.resumen__sucursal:nth-child(3) {
  border-bottom: 4px solid #f19838;
}
.resumen__sucursal:nth-child(4) {
  border-bottom: 4px solid #ee7c31;
}
.resumen__sucursal:nth-child(5) {
  border-bottom: 4px solid #61ac42;
}

.resumen__sucursal > div:nth-child(1) {
  width: 68%;
  margin-right: 2%;
  font-size: 12px;
  display: flex;
  flex-direction: column;
  justify-content: flex-end;
}
.resumen__sucursal > div:nth-child(2) {
  width: 30%;
  display: flex;
  align-items: center;
}
.resumen__sucursal > div:nth-child(2) img {
  width: 96%;
  margin: auto;
}

.resumen__sucursal > div > div:nth-child(1) {
}

.resumen__sucursal:hover {
  background-color: #fff9e6;
}
.txt {
  display: block;
  font-size: 21px;
  font-family: "Avenir_Next_Demi_Bold";
}
@media screen and (max-width: 900px) {
  .resumen {
    grid-template-columns: repeat(12, 1fr);
  }
  .resumen .col2 {
    grid-column: auto / span 3;
  }
}
@media screen and (max-width: 799px) {
  .resumen .col2 {
    grid-column: auto / span 4;
  }
}
</style>